# -*- coding: utf-8 -*-
# Obchod, 6a1, 2.3.2012, 9.3., 23.3.
from Tkinter import *
from random import randint
class udalost:
  def __init__(self,sz,sc,st):
    self.z=sz   # jaký zákazník
    self.c=sc   # v kolik hodin (počet sekund)
    self.t=st   # typ události (co má dělat)
                # 0..příchod,1..pokladny,2..odchod
#u=udalost(franta,1279,0)

class kalendar:
  def __init__(self):
    self.udalosti=[]  #seznam událostí je na začátku prázdný
  def vloz(self,u):   #zatřídí událost u
    vlozeno=0
    for i in range(len(self.udalosti)):
      if (self.udalosti[i].c>u.c):   #našli jsme místo
         self.udalosti=self.udalosti[:i]+[u]+self.udalosti[i:]
         vlozeno=1
         break  #předčasné ukončení cyklu
    if (vlozeno==0):
      self.udalosti=self.udalosti+[u]
  def odevzdej(self):  #vrátí první uálosti
    return self.udalosti.pop(0)
      
class pokladna:
  def __init__(self,so,sr):
    self.o=so       #odkaz na obchod 
    self.fronta=[]  #nikdo není ve frontě
    self.rychlost=sr #rychlost pokladního
    self.prodano=0   #počet odbavených položek
    self.volno=1     #na začátku je volno
    self.delka=Scale(self.o.okno,from_=0, to=100, orient=HORIZONTAL, fg="red")
    self.delka.pack()
    self.delka.set(0)
  def dofronty(self,z):
    self.fronta.append(z)
    self.delka.set(len(self.fronta))
    if(len(self.fronta)>10):
      self.o.pridejkasu()
    #self.delka['text']=str(len(self.fronta))
  def zfronty(self):
    z=self.fronta.pop(0)
    self.delka.set(len(self.fronta))
    #self.delka['text']=str(len(self.fronta))
    return z

class obchod:
  def __init__(self):
    self.okno=Tk()
    self.cas=0   #čas od začátku simulace
    self.pocet=0 #počet zákazníků uvnitř
    self.novakasa=Button(self.okno, text="Přidej pokladnu", command=self.pridejkasu)
    self.novakasa.pack()
    self.naval = Scale(self.okno,from_=2, to=120, orient=HORIZONTAL,)
    self.naval.set(30)
    self.naval.pack()
    self.popisek2=Label(self.okno,text="Hodin:")
    self.popisek2.pack()
    self.hodiny=Label(self.okno,text="0:0")
    self.hodiny.pack()
    self.popisek1=Label(self.okno,text="Zákazníků:")
    self.popisek1.pack()
    self.zakazniku=Label(self.okno,text="0")
    self.zakazniku.pack()
    self.popisek3=Label(self.okno,text="Pokladen:")
    self.popisek3.pack()
    self.pokladen=Label(self.okno,text="1")
    self.pokladen.pack()
    self.pokladny=[] #seznam pokladen
    for i in range(1):  #chci pět pokladny
      self.pokladny.append(pokladna(self,i+2))
      # 1. pokladna má rychlost 2, druhá 3, třetí 4
    self.k=kalendar()
    z=zakaznik(self)
    u=udalost(z,0,0)
    self.k.vloz(u)
    self.krok()
    # nastartovat simulaci
  def pridejkasu(self):
    self.pokladny.append(pokladna(self,randint(2,10)))
    self.pokladen['text']=str(len(self.pokladny))
  def krok(self): # vezme událost z kalendáře a provede jí
    if (self.k.udalosti!=[]):  # v kalendáři něco je
      u=self.k.odevzdej()      # vezmu aktuální událost
      self.cas=u.c             # nastavit čas podle události
      self.hodiny['text']=str(self.cas/3600)+":"+str(self.cas/60-self.cas/3600*60)
      if (u.t==0):
        u.z.prichod()          #událost příchodu
      elif (u.t==1):
	u.z.volba()            #událost volby pokladny
      else:
	u.z.odchod()           #událost placení a odchod
      self.okno.after(10,self.krok)  # jdu vzít další událost
    
class zakaznik:
  def __init__(self,so):
    self.o=so #odkaz na obchod
    self.kusy=randint(1,50)  #počet položek ke koupení
    self.casprichodu=0
    self.pokladna=0
    self.stav=0
  def prichod(self):
    self.o.pocet=self.o.pocet+1
    print(self.o.pocet)
    self.o.zakazniku['text']= str(self.o.pocet)
    #plánování volby pokladny
    t=self.o.cas+30+self.kusy*randint(10,120) #čas kdy chci jít k pokladnám
    u=udalost(self,t,1)
    self.o.k.vloz(u)
    #naplánovat příchod dalšího zákazníka
    z=zakaznik(self.o)
    t=self.o.cas+self.o.naval.get()
    u=udalost(z,t,0)
    self.o.k.vloz(u)
  def volba(self):
    #vybrat pokladnu-teď už chytře
    pn = self.o.pokladny[0]
    for p in self.o.pokladny:
      if (len(p.fronta)<len(pn.fronta)):
        pn = p
    self.pokladna=pn
    #self.pokladna=self.o.pokladny[randint(0,4)]
    if (self.pokladna.volno==1):
      self.pokladna.volno=0
      self.pokladna.delka['fg']="black"
      #plánování placení
      t=self.o.cas+30+self.kusy*self.pokladna.rychlost
      u=udalost(self,t,2)
      self.o.k.vloz(u)
    else:
      self.pokladna.dofronty(self) #pošlu sebe do fronty
  def odchod(self):
    self.o.pocet=self.o.pocet-1
    print(self.o.pocet)
    if (self.pokladna.fronta!=[]): #fronta není prázda
      z=self.pokladna.zfronty()
      #plánování placení
      t=self.o.cas+30+z.kusy*self.pokladna.rychlost
      u=udalost(z,t,2)
      self.o.k.vloz(u)
    else:
      self.pokladna.volno=1
      self.pokladna.delka['fg']="red"
      #zrušení volné pokladny
      if(len(self.o.pokladny)>1):
	self.pokladna.delka.destroy() #smazání widgetu
	self.o.pokladny.remove(self.pokladna)
      
o=obchod()
mainloop()